P486
		assume cs:codesg, ds:codesg
codesg        segment USE16
scansort2     proc   far
entry:        mov    dx,seg emp_seg
		mov    ds,dx
		mov    bx,ss
		sub    bx,dx
		shl    bx,4          ; Shift w/zeros fill
		cli                  ; Disable interrupts
		mov    ss,dx
		add    sp,bx
		sti                  ; Enable interrupts
		mov    bx,sp
		add    bx,0Fh
		shr    bx,4          ; Shift w/zeros fill
		mov    ax,ss
		add    bx,ax
		mov    ax,es
		sub    bx,ax
		mov    ah,4Ah
		int    21h           ; DOS Services  ah=function 4Ah
					; change memory allocation
					; bx=bytes/16, es=mem segment

		push cs              ;display banner
		pop ds
		lea dx,banner
		mov ah,9
		int 21h

		
		mov ah,48h           ;alloc mem for bios backup
		mov bx,1000h
		int 21h
		jnc memok
		jmp error

memok:        mov word ptr cs:[oldseg],ax              
		mov es,ax
		mov dx,0f000h        ;backup bios
		mov ds,dx
		xor di,di
		xor si,si
		mov cx,0ffffh
		rep movsb
		movsb
		
		mov ah,48h           ;alloc memory for image
		mov bx,1000h
		int 21h
		jnc memok1
		jmp error

memok1:       push ax
		wbinvd               ;flush int&ext cache

		mov dx,22h
		mov al,52h
		out dx,al
		jcxz $+2
		jcxz $+2
		mov dx,23h
		in al,dx             ;save shadow control register state
		jcxz $+2
		jcxz $+2             
		mov byte ptr cs:[sh_reg],al 
		mov al,1000000b
		cli
		out dx,al            ;turn off bios shadow
		jcxz $+2
		jcxz $+2
		
		pop ax               ;get image
		push ax
		mov es,ax
		mov dx,0f000h
		mov ds,dx
		xor di,di
		xor si,si
		mov cx,0ffffh
		rep movsb
		movsb

		mov dx,22h           ;enable bios shadow & write
		mov al,52h
		out dx,al
		jcxz $+2
		jcxz $+2
		mov dx,23h
		mov al,10000000b
		out dx,al
		jcxz $+2
		jcxz $+2

		mov ax,word ptr cs:[oldseg] 
		mov ds,ax
		mov dx,0f000h        ;restore bios
		mov es,dx
		xor di,di
		xor si,si
		mov cx,0ffffh
		rep movsb
		movsb

		mov dx,22h           ;restore shadow control register
		mov al,52h
		out dx,al
		jcxz $+2
		jcxz $+2
		mov dx,23h
		mov al,byte ptr cs:[sh_reg]
		out dx,al
		jcxz $+2
		jcxz $+2
		
		sti

		mov ax,3c00h         ;create image file
		xor cx,cx
		push cs 
		pop ds
		lea dx,storage
		int 21h
		jnc ner1
		jmp error            ;ax=handle
		
      ner1:   pop ds               ;write image
		mov bx,ax
		mov ax,4000h
		xor dx,dx
		mov cx,0ffffh
		int 21h
		jnc noerr
		jmp error

	noerr: mov ax,4000h         ;the last byte =)
		mov dx,0ffffh
		mov cx,1
		int 21h
		jnc noerr2
		jmp error

      noerr2: mov ax,3e00h
		int 21h              ;close file
		jc error
		jmp ok

error:        push cs              ;display error msg
		pop ds
		add al,30h
		mov byte ptr cs:[io_code],al
		lea dx,io_error
		mov ah,9
		int 21h              ;display err msg
		mov al,1             ;return error code

	ok:    mov    ah,4Ch       
		int    21h           ; DOS Services  ah=function 4Ch
					; terminate with al=return code
scansort2     endp


io_error  db     0Ah,0Dh,'DOS error ('
io_code   db     0,')$'
storage   db     'SIS471.BIN',0 
oldseg    dw  0
banner    db  'SiS-471 BIOS Image Write 1.00 by ThunderBAUD',0dh,0ah
	   db  'Do not try run it with other chipsets',0dh,0ah
	   db  'Does not work in VM8086 processor mode$',0dh,0ah
sh_reg        db 0

codesg        ends

emp_seg segment stack
emp_seg ends

end
